
#!/usr/local/bin/perl -w

$bases=6;
$width=16;

%basis_code=("00",0,
	     "01",1,
	     "10",-1,
	     "11",2);
		
$mask='';

for ($i=0 ; $i < 2**(2*$bases); $i++){
    vec($mask,0,$width) = $i;


    $bits=substr(unpack("B$width",$mask),4);

    $bits=join("",reverse(unpack("a2a2a2a2a2a2",$bits)));

    $found{-1}=$found{1}=0;

    $pos=-1;
    $found_zero=0;
    $comment[$i]="/* ";
    $comment[$i].= $i."\t".$bits;

    for ($j=0; $j< $bases/2; $j++){
	$a=$basis_code{substr($bits,4*$j,2)};
	$b=$basis_code{substr($bits,4*$j+2,2)};


	if ($a==0){
	    $other_sign=$b;
	    $found_zero++;
	    $pos=2*$j;
	}
	if ($b==0){
	    $other_sign=$a;
	    $found_zero++;
	    $pos=2*$j+1;
	}

	    
	$s=$a * $b;
	$found{$s}=1;
	
	$comment[$i] .=sprintf "\t%02d,%02d",$a, $b;
    }
    
    $comment[$i] .= " */";


    if ($found{1} && $found{-1}) {
	$missing=0;
    } elsif ($found{1} && !$found{-1}) {
	$missing=-1;
    } elsif (!$found{1} && $found{-1}) {
	$missing=1;
    }	else {
	$missing=2;
    }
    $missing *= $other_sign;

    $pos=-1 if ($found_zero > 1);
    $missing=0 if ($found_zero>1);

    $forced_col[$i]=$pos;
    $forced_sign[$i]=$missing; 
}

printf("/** Autogenerated by $0 %s*/\n",scalar(localtime()));
print "#undef DOXYGEN_SKIP\n";
print "#ifndef DOXYGEN_SKIP\n";
print "small_int forced_col[]={\n";
for ($i=0 ; $i < 2**(2*$bases); $i++){
    print $forced_col[$i].",\t".$comment[$i]."\n";
}
print "};\n";

print "small_int forced_sign[]={\n";
for ($i=0 ; $i < 2**(2*$bases); $i++){
    print $forced_sign[$i].",\t".$comment[$i]."\n";
}
print "};\n";
printf "#endif\n";
