package Chirotope;
use Carp qw(confess carp);
use FilterConfig;
use FilterUtil qw(run_command);



sub new {
  my $invokant=shift;
  my $class=ref $invokant || $invokant;
  my %arg=@_;

  confess "must define rank, elements, signs" 
    unless (defined($arg{rank}) && defined($arg{signs}) 
	    && defined($arg{elements}));
  

  return bless ( { ELEMENTS=>$arg{elements},
		   RANK=>$arg{rank},
		   SIGNS=> $arg{signs} },$class);
}

sub from_pm(@){
  local ($_)=join('',@_);

  my ($elements,$rank);

  s/^\s*(\d+)\s*,\s*(\d+)\s*:// || confess "missing elements,rank";
  
  ($elements,$rank)=($1,$2);

  s/\s//g;

  my @signs=split('');

  return new Chirotope(elements=>$elements, 
		       rank=>$rank,
		       signs=>[@signs]);
}

sub rank($){
  my $self=shift;
  
  return $self->{RANK};
}
sub elements($){
  my $self=shift;
  
  return $self->{ELEMENTS};
}

sub to_pm($){
  my $self=shift;

  return sprintf("%d,%d: ",$self->elements, $self->rank).
    join('',
	 map( defined($_) ? $_ : '?' , @{$self->{SIGNS}}));
  
}

sub facets($){
  my $self=shift;

  my @output=run_command($CHIRO_FACET_CMD,
			 $self->to_pm());

  return FacetList::from_topcom(@output);

}
1;
